100 REMark Roman Numerals (C) Dilwyn Jones, 1985
110 MODE 8:PAPER 0:WINDOW 512,256,0,0:CLS
120 WINDOW 452,220,30,16:BORDER 2,255
130 PAPER 6:INK 0:CSIZE 2,0:CLS:PAPER 0:INK 6
140 PRINT'      ROMAN NUMERALS CONVERSION      '
150 WINDOW 444,206,34,28:PAPER 6:INK 0:CLS
160 DIM hun$(9,4),ten$(9,4),one$(9,4),roman$(7,1),decim(7)
170 hun$(0)='':ten$(0)='':one$(0)='':roman$(0)='':decim(0)=0
180 RESTORE 
190 FOR num=1 TO 7:READ roman$(num),decim(num)
200 FOR num=1 TO 9:READ hun$(num),ten$(num),one$(num)
210 DATA 'M',1000,'D',500,'C',100,'L',50,'X',10,'V',5,'I',1
220 DATA 'C','X','I','CC','XX','II','CCC','XXX','III'
230 DATA 'CD','XL','IV','D','L','V','DC','LX','VI'
240 DATA 'DCC','LXX','VII','DCCC','LXXX','VIII','CM','XC','IX'
250 REPeat program
260  CLS:PRINT\'         ------------------'
270  PRINT'          DO YOU WANT TO :'
280  PRINT'         ------------------'
290  PRINT\'    1 - Convert Roman To Decimal'
300  PRINT'    2 - Convert Decimal To Roman'
310  PRINT\TO 13;'ESC - Quit'
320  PRINT\\'        (Press 1, 2, or ESC)';
330  REPeat gk
340   key=CODE(INKEY$(-1))
350   SELect ON key=27,49,50:EXIT gk
360   BEEP 5000,50
370  END REPeat gk
380  IF key=27 THEN EXIT program
390  IF key=49 THEN RtoD:ELSE DtoR
400  IF number$<>'' THEN 
410   PRINT\\'Press any key...';
420   PAUSE
430  END IF 
440 END REPeat program
450 PRINT\\'PROGRAM FINISHED.'
460 STOP
470 DEFine PROCedure RtoD
480  CLS
490  REPeat loop
500   valid=1
510   INPUT'Enter a Roman number:';number$
520   IF number$='' THEN valid=0:EXIT loop
530   valid=1
540   FOR num=1 TO LEN(number$):IF (number$(num) INSTR 'MDCLXVI')=0 THEN valid=0
550   IF valid THEN EXIT loop
560   PRINT'Error...'
570  END REPeat loop
580  IF number$='' THEN RETurn 
590  total=0:subscript=1
600  REPeat conv
610   IF subscript>LEN(number$) THEN EXIT conv
620   num1$=number$(subscript):first=0
630   FOR rom=1 TO 7:IF num1$==roman$(rom) THEN first=decim(rom):EXIT rom
640   IF first=0 THEN PRINT'Error...':EXIT conv
650   subscript=subscript+1
660   IF subscript>LEN(number$) THEN total=total+first:EXIT conv
670   num2$=number$(subscript):second=0
680   FOR rom=1 TO 7:IF num2$==roman$(rom) THEN second=decim(rom):EXIT rom
690   IF second=0 THEN PRINT'Error...':EXIT conv
700   IF first>=second THEN total=total+first:ELSE total=total+second-first:subscript=subscript+1
710  END REPeat conv
720  IF total>0 AND total<5000 THEN CLS:PRINT'Roman ';number$\' = decimal ';total
730  IF total>4999 THEN PRINT\'Error...'
740 END DEFine RtoD
750 DEFine PROCedure DtoR
760  CLS
770  REPeat loop
780   INPUT'Decimal number:';number$
790   IF number$='' THEN EXIT loop
800   IF LEN(number$)<5 THEN 
810    valid=1
820    FOR a=1 TO LEN(number$)
830     IF number$(a)<'0' OR number$(a)>'9' THEN valid=0
840    END FOR a
850    IF valid THEN 
860     de=number$
870     SELect ON de=1 TO 4999:EXIT loop
880    END IF 
890   END IF 
900   PRINT'Error...'
910  END REPeat loop
920  IF number$='' THEN RETurn 
930  decimal$=''
940  decimal$=decimal$&FILL$('M',de DIV 1000)&hun$((de MOD 1000) DIV 100)&ten$((de MOD 100) DIV 10)&one$(de MOD 10)
950  PRINT'Decimal ';number$\' = Roman ';decimal$
960 END DEFine DtoR
